Unit ZP14R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP10_p;

procedure ZP14R(A :Real; B :Real; C :Real; var ROOT1 :Complex;
                var ROOT2 :Complex; var IERR :Integer);

implementation

procedure ZP14R(A :Real; B :Real; C :Real; var ROOT1 :Complex;
                var ROOT2 :Complex; var IERR :Integer);
var
IS_ :Integer;
A0,B0,B1,C0,S,SCALE,DD :Real;
D,D1 :Extended;
ZS,ZL :Complex;
const
SYS063 :Real = 2.0;
SYS065 :Real = 6.931472E-1;
ZERO :Real = 0.0;
HALF :Real = 0.5;
SYS059 :Real = 3.4E38;  //  Delphi>3
label
_1,_2,_3,_4,_5,_6;
begin
IERR := 0;
A0 := A;
B1 := -B;
C0 := C;
if ( A0 <> ZERO ) 
 then goto _1;
IERR := 65;
ZL := Cmplx(Sign(SYS059,ZERO),0.0);
ZS := SubC(Cmplx(0.0,0.0),ZL);
if ( B1 = ZERO ) 
 then goto _6;
IERR := 66;
ZS := Cmplx(C0/B1,ZERO);
goto _6;
_1:
if ( C0 <> ZERO ) 
 then goto _2;
ZS := Cmplx(ZERO,ZERO);
goto _5;
_2:
IS_ := Trunc( (Ln(Abs(A0))+Ln(Abs(C0))+SYS065)/(SYS065+
    SYS065) );
SCALE := IntPower(SYS063,IS_);
D1 := (Abs(B1));
D := D1+SCALE;
D := D-D1;
if ( (D) = ZERO ) 
 then goto _4;
B0 := ZERO;
D := D1+SCALE;
D := D-SCALE;
if ( (D) <> ZERO ) 
 then B0 := (B1/SCALE)*HALF;
A0 := A0/SCALE;
C0 := C0/SCALE;
DD := IntPower(B0,2)-(A0)*(C0);
S := Sqrt(Abs(DD));
if ( DD > ZERO ) 
 then goto _3;
ZL := Cmplx(B0/A0,Abs(S/A0));
ZS := Conjg(ZL);
goto _6;
_3:
B1 := Sign(S,B0)+B0;
_4:
ZS := Cmplx(C0/B1,ZERO);
_5:
ZL := Cmplx(B1/A0,ZERO);
if ( Abs(Creal(ZL)) < Abs(Creal(ZS)) ) 
 then ZS := SubC(Cmplx(0.0,0.0),ZL);
_6:
ROOT1 := ZS;
ROOT2 := ZL;
if ( IERR <> 0 ) 
 then UTZP10(IERR,14);
end;

end.
